<html>
<head>
<title>Ogre::OptimisedUtil Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-static-methods">Static Protected Member Functions</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a> &#124;
<a href="#pri-methods">Private Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::OptimisedUtil Class Reference<div class="ingroups"><a class="el" href="group__Math.html">Math</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::OptimisedUtil" -->
<p>Utility class for provides optimised functions.  
 <a href="classOgre_1_1OptimisedUtil.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreOptimisedUtil_8h_source.html">OgreOptimisedUtil.h</a>&gt;</code></p>

<p><a href="classOgre_1_1OptimisedUtil-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#a4f137d0ced0f82abd042d9b4eb99b105">OptimisedUtil</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#a7d548511ecbd6b39d6d1689ce30db8f2">~OptimisedUtil</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#a69ac35f1a13aa95e2352d0fbbbb204b9">softwareVertexSkinning</a> (const float *srcPosPtr, float *destPosPtr, const float *srcNormPtr, float *destNormPtr, const float *blendWeightPtr, const unsigned char *blendIndexPtr, const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *const *blendMatrices, size_t srcPosStride, size_t destPosStride, size_t srcNormStride, size_t destNormStride, size_t blendWeightStride, size_t blendIndexStride, size_t numWeightsPerVertex, size_t numVertices)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Performs software vertex skinning.  <a href="#a69ac35f1a13aa95e2352d0fbbbb204b9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#a431efac44c070695de7011243b13b7af">softwareVertexMorph</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> t, const float *srcPos1, const float *srcPos2, float *dstPos, size_t pos1VSize, size_t pos2VSize, size_t dstVSize, size_t numVertices, bool morphNormals)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.  <a href="#a431efac44c070695de7011243b13b7af"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#a45b0aaad519e4cace9ca37124f4e646d">concatenateAffineMatrices</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;baseMatrix, const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *srcMatrices, <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *dstMatrices, size_t numMatrices)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Concatenate an affine matrix to an array of affine matrices.  <a href="#a45b0aaad519e4cace9ca37124f4e646d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#a7fa20b34357e375a489383f0ccb4a15c">calculateFaceNormals</a> (const float *positions, const <a class="el" href="structOgre_1_1EdgeData_1_1Triangle.html">EdgeData::Triangle</a> *triangles, <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> *faceNormals, size_t numTriangles)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the face normals for the triangles based on position information.  <a href="#a7fa20b34357e375a489383f0ccb4a15c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#a9270e6273fcf190d039030bd5de1df2f">calculateLightFacing</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> *faceNormals, char *lightFacings, size_t numFaces)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the light facing state of the triangle's face normals.  <a href="#a9270e6273fcf190d039030bd5de1df2f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#a5b411cfc1b916483d75df4f4f9c86252">extrudeVertices</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> extrudeDist, const float *srcPositions, float *destPositions, size_t numVertices)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Extruding vertices by a fixed distance based on light position.  <a href="#a5b411cfc1b916483d75df4f4f9c86252"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#aec3039ddfa064375bb4065a4415a8eda">getImplementation</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the implementation of this class.  <a href="#aec3039ddfa064375bb4065a4415a8eda"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-methods"></a>
Static Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#abf6a2bcd2039d05d83671e2da3140112">_detectImplementation</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Detect best implementation based on run-time environment.  <a href="#abf6a2bcd2039d05d83671e2da3140112"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#af1214c854c521f84997b5ddf77f1a3a5">msImplementation</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Store a pointer to the implementation.  <a href="#af1214c854c521f84997b5ddf77f1a3a5"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#acd57a62f0ea9db4ef52b4d39d83fd019">OptimisedUtil</a> (const <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;rhs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Privated copy constructor, to prevent misuse.  <a href="#acd57a62f0ea9db4ef52b4d39d83fd019"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#ae8975dc2a98c5ae3eb511e8a0336e51e">operator=</a> (const <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;rhs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Privated operator=, to prevent misuse.  <a href="#ae8975dc2a98c5ae3eb511e8a0336e51e"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Utility class for provides optimised functions. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>This class are supposed used by internal engine only. </dd></dl>

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h_source.html#l00047">47</a> of file <a class="el" href="OgreOptimisedUtil_8h_source.html">OgreOptimisedUtil.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="acd57a62f0ea9db4ef52b4d39d83fd019"></a><!-- doxytag: member="Ogre::OptimisedUtil::OptimisedUtil" ref="acd57a62f0ea9db4ef52b4d39d83fd019" args="(const OptimisedUtil &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1OptimisedUtil.html#acd57a62f0ea9db4ef52b4d39d83fd019">Ogre::OptimisedUtil::OptimisedUtil</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Privated copy constructor, to prevent misuse. </p>

</div>
</div>
<a class="anchor" id="a4f137d0ced0f82abd042d9b4eb99b105"></a><!-- doxytag: member="Ogre::OptimisedUtil::OptimisedUtil" ref="a4f137d0ced0f82abd042d9b4eb99b105" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1OptimisedUtil.html#acd57a62f0ea9db4ef52b4d39d83fd019">Ogre::OptimisedUtil::OptimisedUtil</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h_source.html#l00064">64</a> of file <a class="el" href="OgreOptimisedUtil_8h_source.html">OgreOptimisedUtil.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7d548511ecbd6b39d6d1689ce30db8f2"></a><!-- doxytag: member="Ogre::OptimisedUtil::~OptimisedUtil" ref="a7d548511ecbd6b39d6d1689ce30db8f2" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1OptimisedUtil.html#a7d548511ecbd6b39d6d1689ce30db8f2">Ogre::OptimisedUtil::~OptimisedUtil</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h_source.html#l00066">66</a> of file <a class="el" href="OgreOptimisedUtil_8h_source.html">OgreOptimisedUtil.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="abf6a2bcd2039d05d83671e2da3140112"></a><!-- doxytag: member="Ogre::OptimisedUtil::_detectImplementation" ref="abf6a2bcd2039d05d83671e2da3140112" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>* <a class="el" href="classOgre_1_1OptimisedUtil.html#abf6a2bcd2039d05d83671e2da3140112">Ogre::OptimisedUtil::_detectImplementation</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Detect best implementation based on run-time environment. </p>

</div>
</div>
<a class="anchor" id="a7fa20b34357e375a489383f0ccb4a15c"></a><!-- doxytag: member="Ogre::OptimisedUtil::calculateFaceNormals" ref="a7fa20b34357e375a489383f0ccb4a15c" args="(const float *positions, const EdgeData::Triangle *triangles, Vector4 *faceNormals, size_t numTriangles)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1OptimisedUtil.html#a7fa20b34357e375a489383f0ccb4a15c">Ogre::OptimisedUtil::calculateFaceNormals</a> </td>
          <td>(</td>
          <td class="paramtype">const float *&#160;</td>
          <td class="paramname"><em>positions</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1EdgeData_1_1Triangle.html">EdgeData::Triangle</a> *&#160;</td>
          <td class="paramname"><em>triangles</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a> *&#160;</td>
          <td class="paramname"><em>faceNormals</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numTriangles</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculate the face normals for the triangles based on position information. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">positions</td><td>Pointer to position information, which packed in (x, y, z) format, indexing by vertex index in the triangle. No alignment requests. </td></tr>
    <tr><td class="paramname">triangles</td><td>The triangles need to calculate face normal, the vertex positions is indexed by vertex index to position information. </td></tr>
    <tr><td class="paramname">faceNormals</td><td>The array of <a class="el" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> used to store triangles face normal, Must be aligned to SIMD alignment. </td></tr>
    <tr><td class="paramname">numTriangles</td><td>Number of triangles to calculate face normal. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9270e6273fcf190d039030bd5de1df2f"></a><!-- doxytag: member="Ogre::OptimisedUtil::calculateLightFacing" ref="a9270e6273fcf190d039030bd5de1df2f" args="(const Vector4 &amp;lightPos, const Vector4 *faceNormals, char *lightFacings, size_t numFaces)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1OptimisedUtil.html#a9270e6273fcf190d039030bd5de1df2f">Ogre::OptimisedUtil::calculateLightFacing</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&#160;</td>
          <td class="paramname"><em>lightPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> *&#160;</td>
          <td class="paramname"><em>faceNormals</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>lightFacings</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numFaces</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculate the light facing state of the triangle's face normals. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is normally the first stage of calculating a silhouette, i.e. establishing which tris are facing the light and which are facing away. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lightPos</td><td>4D position of the light in object space, note that for directional lights (which have no position), the w component is 0 and the x/y/z position are the direction. </td></tr>
    <tr><td class="paramname">faceNormals</td><td>An array of face normals for the triangles, the face normal are unit vector orthogonal to the triangles, plus distance from origin. This array must be aligned to SIMD alignment. </td></tr>
    <tr><td class="paramname">lightFacings</td><td>An array of flags for store light facing state results, the result flag is true if corresponding face normal facing the light, false otherwise. This array no alignment requires. </td></tr>
    <tr><td class="paramname">numFaces</td><td>Number of face normals to calculate. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a45b0aaad519e4cace9ca37124f4e646d"></a><!-- doxytag: member="Ogre::OptimisedUtil::concatenateAffineMatrices" ref="a45b0aaad519e4cace9ca37124f4e646d" args="(const Matrix4 &amp;baseMatrix, const Matrix4 *srcMatrices, Matrix4 *dstMatrices, size_t numMatrices)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1OptimisedUtil.html#a45b0aaad519e4cace9ca37124f4e646d">Ogre::OptimisedUtil::concatenateAffineMatrices</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>baseMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&#160;</td>
          <td class="paramname"><em>srcMatrices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&#160;</td>
          <td class="paramname"><em>dstMatrices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numMatrices</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Concatenate an affine matrix to an array of affine matrices. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>An affine matrix is a 4x4 matrix with row 3 equal to (0, 0, 0, 1), e.g. no projective coefficients. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">baseMatrix</td><td>The matrix used as first operand. </td></tr>
    <tr><td class="paramname">srcMatrices</td><td>An array of matrix used as second operand. </td></tr>
    <tr><td class="paramname">dstMatrices</td><td>An array of matrix to store matrix concatenate results. </td></tr>
    <tr><td class="paramname">numMatrices</td><td>Number of matrices in the array. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5b411cfc1b916483d75df4f4f9c86252"></a><!-- doxytag: member="Ogre::OptimisedUtil::extrudeVertices" ref="a5b411cfc1b916483d75df4f4f9c86252" args="(const Vector4 &amp;lightPos, Real extrudeDist, const float *srcPositions, float *destPositions, size_t numVertices)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1OptimisedUtil.html#a5b411cfc1b916483d75df4f4f9c86252">Ogre::OptimisedUtil::extrudeVertices</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&#160;</td>
          <td class="paramname"><em>lightPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>extrudeDist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&#160;</td>
          <td class="paramname"><em>srcPositions</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>destPositions</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numVertices</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Extruding vertices by a fixed distance based on light position. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lightPos</td><td>4D light position, when w=0.0f this represents a directional light, otherwise, w must be equal to 1.0f, which represents a point light. </td></tr>
    <tr><td class="paramname">extrudeDist</td><td>The distance to extrude. </td></tr>
    <tr><td class="paramname">srcPositions</td><td>Pointer to source vertex's position buffer, which the position is a 3D vector packed in xyz format. No SIMD alignment requirement but loss performance for unaligned data. </td></tr>
    <tr><td class="paramname">destPositions</td><td>Pointer to destination vertex's position buffer, which the position is a 3D vector packed in xyz format. No SIMD alignment requirement but loss performance for unaligned data. </td></tr>
    <tr><td class="paramname">numVertices</td><td>Number of vertices need to extruding, which agree with source and destination buffers. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aec3039ddfa064375bb4065a4415a8eda"></a><!-- doxytag: member="Ogre::OptimisedUtil::getImplementation" ref="aec3039ddfa064375bb4065a4415a8eda" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>* <a class="el" href="classOgre_1_1OptimisedUtil.html#aec3039ddfa064375bb4065a4415a8eda">Ogre::OptimisedUtil::getImplementation</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the implementation of this class. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>Don't cache the pointer returned by this function, it'll change due run-time environment detection to pick up the best implementation. </dd></dl>

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h_source.html#l00073">73</a> of file <a class="el" href="OgreOptimisedUtil_8h_source.html">OgreOptimisedUtil.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae8975dc2a98c5ae3eb511e8a0336e51e"></a><!-- doxytag: member="Ogre::OptimisedUtil::operator=" ref="ae8975dc2a98c5ae3eb511e8a0336e51e" args="(const OptimisedUtil &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>&amp; Ogre::OptimisedUtil::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Privated operator=, to prevent misuse. </p>

</div>
</div>
<a class="anchor" id="a431efac44c070695de7011243b13b7af"></a><!-- doxytag: member="Ogre::OptimisedUtil::softwareVertexMorph" ref="a431efac44c070695de7011243b13b7af" args="(Real t, const float *srcPos1, const float *srcPos2, float *dstPos, size_t pos1VSize, size_t pos2VSize, size_t dstVSize, size_t numVertices, bool morphNormals)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1OptimisedUtil.html#a431efac44c070695de7011243b13b7af">Ogre::OptimisedUtil::softwareVertexMorph</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&#160;</td>
          <td class="paramname"><em>srcPos1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&#160;</td>
          <td class="paramname"><em>srcPos2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>dstPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>pos1VSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>pos2VSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>dstVSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numVertices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>morphNormals</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This function will linearly interpolate positions between two source buffers, into a third buffer. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">t</td><td>Parametric distance between the start and end positions </td></tr>
    <tr><td class="paramname">srcPos1</td><td>Pointer to buffer for the start positions </td></tr>
    <tr><td class="paramname">srcPos2</td><td>Pointer to buffer for the end positions </td></tr>
    <tr><td class="paramname">dstPos</td><td>Pointer to buffer for the destination positions </td></tr>
    <tr><td class="paramname">pos1VSize,pos2VSize,dstVSize</td><td>Vertex sizes in bytes of each of the 3 buffers referenced </td></tr>
    <tr><td class="paramname">numVertices</td><td>Number of vertices to morph, which agree with the number in start, end and destination buffer. Bear in mind three floating-point values per vertex </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a69ac35f1a13aa95e2352d0fbbbb204b9"></a><!-- doxytag: member="Ogre::OptimisedUtil::softwareVertexSkinning" ref="a69ac35f1a13aa95e2352d0fbbbb204b9" args="(const float *srcPosPtr, float *destPosPtr, const float *srcNormPtr, float *destNormPtr, const float *blendWeightPtr, const unsigned char *blendIndexPtr, const Matrix4 *const *blendMatrices, size_t srcPosStride, size_t destPosStride, size_t srcNormStride, size_t destNormStride, size_t blendWeightStride, size_t blendIndexStride, size_t numWeightsPerVertex, size_t numVertices)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1OptimisedUtil.html#a69ac35f1a13aa95e2352d0fbbbb204b9">Ogre::OptimisedUtil::softwareVertexSkinning</a> </td>
          <td>(</td>
          <td class="paramtype">const float *&#160;</td>
          <td class="paramname"><em>srcPosPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>destPosPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&#160;</td>
          <td class="paramname"><em>srcNormPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>destNormPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&#160;</td>
          <td class="paramname"><em>blendWeightPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned char *&#160;</td>
          <td class="paramname"><em>blendIndexPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *const *&#160;</td>
          <td class="paramname"><em>blendMatrices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>srcPosStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>destPosStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>srcNormStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>destNormStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>blendWeightStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>blendIndexStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numWeightsPerVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numVertices</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Performs software vertex skinning. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">srcPosPtr</td><td>Pointer to source position buffer. </td></tr>
    <tr><td class="paramname">destPosPtr</td><td>Pointer to destination position buffer. </td></tr>
    <tr><td class="paramname">srcNormPtr</td><td>Pointer to source normal buffer, if NULL, means blend position only. </td></tr>
    <tr><td class="paramname">destNormPtr</td><td>Pointer to destination normal buffer, it's ignored if srcNormPtr is NULL. </td></tr>
    <tr><td class="paramname">blendWeightPtr</td><td>Pointer to blend weight buffer. </td></tr>
    <tr><td class="paramname">blendIndexPtr</td><td>Pointer to blend index buffer. </td></tr>
    <tr><td class="paramname">blendMatrices</td><td>An array of pointer of blend matrix, the matrix must be aligned to SIMD alignment, but not necessary for the array itself. </td></tr>
    <tr><td class="paramname">srcPosStride</td><td>The stride of source position in bytes. </td></tr>
    <tr><td class="paramname">destPosStride</td><td>The stride of destination position in bytes. </td></tr>
    <tr><td class="paramname">srcNormStride</td><td>The stride of source normal in bytes, it's ignored if srcNormPtr is NULL. </td></tr>
    <tr><td class="paramname">destNormStride</td><td>The stride of destination normal in bytes, it's ignored if srcNormPtr is NULL. </td></tr>
    <tr><td class="paramname">blendWeightStride</td><td>The stride of blend weight buffer in bytes. </td></tr>
    <tr><td class="paramname">blendIndexStride</td><td>The stride of blend index buffer in bytes. </td></tr>
    <tr><td class="paramname">numWeightsPerVertex</td><td>Number of blend weights per-vertex, as well as for blend indices. </td></tr>
    <tr><td class="paramname">numVertices</td><td>Number of vertices to blend. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="af1214c854c521f84997b5ddf77f1a3a5"></a><!-- doxytag: member="Ogre::OptimisedUtil::msImplementation" ref="af1214c854c521f84997b5ddf77f1a3a5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>* <a class="el" href="classOgre_1_1OptimisedUtil.html#af1214c854c521f84997b5ddf77f1a3a5">Ogre::OptimisedUtil::msImplementation</a><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Store a pointer to the implementation. </p>

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h_source.html#l00057">57</a> of file <a class="el" href="OgreOptimisedUtil_8h_source.html">OgreOptimisedUtil.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreOptimisedUtil_8h_source.html">OgreOptimisedUtil.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:00
</p>
</body>
</html>
